#ifndef PROCESS_BUFFER_H
#define PROCESS_BUFFER_H

//
// ,      
class CProcessBuffer
{
public:

	//
	//   
	//

	explicit CProcessBuffer(HANDLE hProcess);
	~CProcessBuffer();

	//
	//   
	//

	bool alloc(DWORD s);
	void free();

	//
	//   
	//

	bool write(DWORD offset, const void* buff, int size);
	bool read(DWORD offset, void* buff, int size);

	//
	// 
	//

	void* get() const
	{
		return m_buffer;
	}

	DWORD size() const
	{
		return m_size;
	}

private:

	//  !
	CProcessBuffer(const CProcessBuffer& );
	CProcessBuffer& operator=(const CProcessBuffer& );

private:

	char*  m_buffer;
	DWORD  m_size;
	HANDLE m_hProcess;
};

#endif //PROCESS_BUFFER_H